%define real_name URPM

Summary:	URPM module for perl
Name:		perl-%{real_name}
Version:	4.4
Release:	%mkrel 1
License:	GPLv2+ or Artistic
Group:		Development/Perl
Source0:	%{real_name}-%{version}.tar.xz
URL:		http://svn.mandriva.com/cgi-bin/viewvc.cgi/soft/rpm/perl-URPM/
BuildRequires:	perl-devel
BuildRequires:	rpm-devel >= 1:5.3
BuildRequires:	perl(MDV::Packdrakeng)

# we can now expect librpm API to be backward compatible
Requires:	rpm
Conflicts:	rpm < 1:5.3
Requires:	perl(MDV::Packdrakeng)
Provides:	perl(URPM::Build) = %{version}-%{release}
Provides:	perl(URPM::Resolve) = %{version}-%{release}
Provides:	perl(URPM::Signature) = %{version}-%{release}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%define _requires_exceptions perl(URPM::DB)\\|perl(URPM::Package)\\|perl(URPM::Transaction)

%description
The URPM module allows you to manipulate rpm files, rpm header files and
hdlist files and manage them in memory.

%prep
%setup -q -n %{real_name}-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
# (tv) fix segfaulting (#61144); -O1 is OK, -O2 is not, the flag that made the difference is -fno-gcse:
# (proyvind): TODO: still valid with rpm 5.3.6?
# (proyvind): really odd, in addition to disabling -fstack-protector (#61690),
#	      if any optimization level is used, it will cause problems, but if
#	      explicitly enabling all the same optimizations manually, it won't
#	      segfault... Just cowardly working around for now...
%make \
%ifarch %{ix86}
OPTIMIZE="$RPM_OPT_FLAGS -fno-stack-protector -O0 `gcc -O2 -Q --help=optimize|grep enabled|cut -d\  -f3| tr '\n' ' '` -fno-gcse"
%else
OPTIMIZE="$RPM_OPT_FLAGS"
%endif

%check
# skip check suite when building on rpm 4, as some parts of it depends on
# rpm 5.3 to be installed
[ "`rpm --version|sed -e  's/^.* \([0-9]\+\).*/\1/'`" != 4 ] && \
make test

%install
rm -rf %{buildroot}
%makeinstall_std

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README ChangeLog
%{_mandir}/man3/*
%{perl_vendorarch}/URPM.pm
%dir %{perl_vendorarch}/URPM
%{perl_vendorarch}/URPM/*.pm
%dir %{perl_vendorarch}/auto/URPM
%{perl_vendorarch}/auto/URPM/URPM.so


%changelog
* Thu Jan 06 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 4.4-1mdv2011.0
+ Revision: 629151
- new release 4.4:
        o check URPM::Transactin::add() for errors and return them if any
          (#61746)
        o make URPM::Package::get_tag() & URPM::Package::get_tag_modifiers()
          accept string name of tags
        o URPM::DB::traverse_tag() & URPM::DB::traverse_tag_find() will now
          accept all available rpm tags
- yeah, that didn't work, backout previous feeble attempt
- try get around abrt & build system issue by adding a buildconflicts
- ditch ancient Conflicts that no longer serves any purpose
- clean up spec
- ditch versioned part of rpm dependency, versioned conflicts etc. should be
  sufficient for more or less ~equivalent behaviour...
- new release: 4.3
  	o fix issue with packages added to synthesis having disttag/disttag, but
  	  without those added to NVRA, leading to segfault
  	o fix broken support for parsing hdlists, use rpmgi iterator from rpmlib
  	  to simplify code and get packages ordered as an extra benefit in the
  	  process.
  	o URPM::Package::fullname will now always return six items for array in
  	  stead of four to make room for disttag & distepoch, arch will still
  	  be returned as last item (ie. array[5] in stead of array[3]) (#61702)
  	o URPM::Package::files_md5sum() has been renamed to
  	  URPM::Package::files_digest()
  	o fix NEVRA parsing of 'gpg-pubkey'
- new release: 4.2
  	o fix URPM::Package::files()
- add conflicts on older rpm version to ensure upgrade happens in same
  transaction as rpm, otherwise database conversion might happen without urpmi
  restarting right after...
- new release: 4.1
- work around #61690 for now...
- get rpm version dependency from rpm-devel rather than rpm (fixes mdv#61658)
- skip tests when building and rpm 5.3 isn't installed
- do version detection through pkg-config so that we don't need rpm 5.3  binary
- just disable attempt at compat macros for now, suspecting better could be done
  anyways...
- give source a number
- don't unnecessarily redefine tags
  * ditch %%mkrel for rpm5 distepoch/disttag to replace it
- new release: 4.0
- rpm5 branch..
- make queryformat conditional for %%rpm_version

  + Thierry Vignaud <tv@mandriva.org>
    - fix crashing on undefined packages (#54521)
    - reenable $RPM_OPT_FLAGS; whereas -O1 is OK, -O2 is OK too with -fno-gcse to
      stop URPM from segfaulting (#61144)
    - explain
    - disable $RPM_OPT_FLAGS which cause URPM to segfault
    - verify_signature: enable to check signatures against a chrooted rpmdb
      (especially important for installer where there's no rpmdb in / and thus no
      keys to check against)
    - kill re-definition of %%buildroot on Pixel's request
    - fix URL

  + Funda Wang <fwang@mandriva.org>
    - rebuild for perl 5.12.1

  + Olivier Thauvin <nanardon@mandriva.org>
    - 3.36 (minor fix for perl-5.12)
    - 1.67:
      o fix spec2header
      o add functions to evaluate arch/os/platform
    - 1.65 (really fix arch_score evaluation)
    - really rebuild against rpm 4.4.8
    - rebuild for next rpm

  + Sandro Cazzaniga <kharec@mandriva.org>
    - rebuild

  + Jérôme Quelin <jquelin@mandriva.org>
    - rebuild for 5.12

  + Christophe Fergeau <cfergeau@mandriva.com>
    - perl-URPM 3.35:
    - when using auto-select, honour search-medias if some were specified
    - perl-URPM 3.34.1:
    - really fix #57224, I forgot a patch in the previous release
    - 3.34:
    - check for conflicting selected packages before selecting a package (#57224)
      (by Anssi Hannula)
    - forgot tarball
    - 3.33:
    - fix lookup of existing pubkeys (#53710) (by Pascal Terjan)
    - 3.32:
    - backtrack_selected: use set_rejected_and_compute_diff_provides for package
      removal (Anssi Hannula)
    - obey options (keep, nodeps) when unselecting current package in the case
      that was added in 3.31 (Anssi Hannula)
    - 3.31:
    - add support for querying %%disttag & %%distepoch (by Per ?\195?\152yvind Karlsen)
    - clean up and bring back rpm5.org support (by Per ?\195?\152yvind Karlsen)
    - keep track of sources for obsoleted/removed levels (#50666) Anssi Hannula)
    - keep psel/promote info and remove deadlocked pkg instead of aborting upgrade
      (#52105, Anssi Hannula)
    - _handle_conflicts: check all provides for conflicts, not just package name
      (#52135, Anssi Hannula)
    - unselect current package if an avoided package is already selected (#52145,
      Anssi Hannula)
    - do not try to promote to an older package (#52460, Anssi Hannula)
    - add a backtrack entry "conflicts" for avoided packages in backtrack_selected
      (#52153, Anssi Hannula)
    - 3.30:
    - rework public key handling since librpm behaviour has changed. It's no longer
      possible to tell it to add the same key multiple times which was causing
      weird "unable to import pubkey" messages when a mirror contains different
      pubkeys for the same key
    - 3.29:
    - fix regression introduced by fix for bug #47803 (fix by Anssi Hannula).
      Without this patch, urpmi got stuck in an infinite loop when trying
      to upgrade from 2008.1.
    - 3.28:
    - postpone user choices as much as possible to avoid asking the user
      unnecessary questions, (bug #48100, Anssi Hannula)
    - 3.27:
    - don't silently install suggests (bug #47934)
    - fix _handle_diff_provides in case of impossible-to-satisfy selected
      packages (bug #48223, Anssi Hannula)
    - check rep for another pkg providing X if the prev pkg gets removed
      due to a conflict (bug #47803, Anssi Hannula)
    - 3.25
    - previous fix for bug #46874 was bogus, really fix it this time
    - 3.24
    - fix sorting choices on provided version (feature introduced in 3.08,
      but was not working if packages were coming from different repository)
    - when a "Requires:" can be fullfilled by several different packages and
      one of those packages is explicitly required by another package which
      is also being installed, silently choose this package instead of letting
      the choice up to perl-URPM user (fixes bug #46874)

  + Pixel <pixel@mandriva.com>
    - 3.23: fix bad free() (thanks to glibc for detecting it)
    - 3.22:
    - fix scriptlet failing:
      adapt to librpm4.6, rpmtsSetRootDir(ts, "") is forbidden
    - 3.21:
    - adapt to librpm4.6
    - drop list_rpm_tag()
    - 3.20:
    - $trans->run can now return both the translated errors, and some parsable
      errors (useful for example to detect diskspace issues)
    - 3.19: handle flag "replacefiles"
    - 3.18:
    - revert change introduced in 3.16 (it breaks too much, eg
      superuser--priority-upgrade.t test case), and introduce
      $state->{rejected_already_installed} instead
    - add traverse_tag_find(), removed_or_obsoleted_packages()
    - handle $state->{orphans_to_remove} in selected_size() and
      build_transaction_set()
    - 3.16:
    - when not selecting a package because already installed,
      put it in $state->{rejected} with flags {installed}
    - 3.15: fix urpmi wrongly considering epochless conflicts to match any epoch
      in a case when urpmi should upgrade a conflicting package to an actually
      non-conflicting version (cf epochless-conflict-with-promotion urpmi test)
      (Anssi)
    - 3.14: add is_package_installed() in URPM/Resolve.pm (to be used in urpmi 5.20)
    - 3.13: do not ignore dropped provide from updated package (mdvbz#40842)
    - 3.12:
    - do allow to promoting a pkg even if it has unsatisfied require (since the
      code will then fix the unsatisfied require). fixes "big transaction"
      (cf urpmi split-transactions--strict-require.t test_efgh())
    - rpm5.org port done (by Per Oyvind Karlsen)
    - 3.11:
    - restore FILENAME_TAG in generated hdlist (to be compatible with older
      distros where ->filename can rely on it) (thanks to Nanar)
    - 3.10:
    - add filesize to synthesis, add ->filesize to get it, and add
      selected_size_filesize() to compute the sum
    - allow urpmi to know a package was not selected because a newer version is
      installed (#29838)
    - handle new package providing xxx which conflicts with an installed package (#17106)
    - fix sort choices changed in perl-URPM 3.08
    - allow fixing "using one big transaction" that occurs when using --keep
      (#30198)
    - do not add FILENAME_TAG and FILESIZE_TAG to hdlist anymore,
      deprecate ->filename and ->header_filename,
      deprecate URPM::Build build_hdlist and parse_rpms_build_headers
    - 3.08: sort choices on virtual package by provided version (#12645)
    - we can now expect librpm API to be backward compatible
    - rebuild for perl 5.10.0
    - 3.07: fix regression in release 3.06
    - 3.06:
    - add URPM::Package->changelogs, a wrapper around ->changelog_time, ->changelog_name, ->changelog_text
    - resolve kmod requires even if first choice is a source dkms
    - force rebuild
    - 3.05: fix regression in ->parse_rpm (introduced in 3.00)
      (was breaking genhdlist2 and mkcd)
    - 3.04: fix regression in parse_pubkeys() (introduced in 3.00) (#36121)
    - 3.03:
    - suggests:
      handle both RPMTAG_SUGGESTSNAME (as done in SuSE and in Mandriva > 2008.0)
      and RPMTAG_REQUIRENAME + RPMSENSE_MISSINGOK (as done in Mandriva 2008.0)
    - 3.02:
    - fix "make test" on rpm 4.4.2.2
    - fix rpm 4.5 support
    - 3.01: add URPM::DB::verify()
    - 3.00:
    - replace ->import_needed_pubkeys and ->import_pubkey in favor of
      import_needed_pubkeys_from_file() and ->import_pubkey_file
      (! this breaks API !)
    - drop $package->upgrade_files() (unused for a long time afaik)
    - rpm.org HEAD support
    - conflicting with urpmi & drakx-installer-stage2 which use old
      ->import_needed_pubkeys API
    - enable "make test" again
    - 2.10:
    - much simpler --auto-select algorithm
      (fixes #35718, ie auto-selecting with strict-arch)
      (!! DANGEROUS CHANGE !!)
    - rpm 4.5 support (thanks to peroyvind) (#35323)
    - 2.09: use a simple function to return simple string list from header
      (fixes getting >4096 long rpm changelogs)
      (!! static buffer size limitation in callback_list_str_xpush() should be fixed !!)
    - 2.08: fix build on rpm 4.4.2.2
    - 2.07:
    - prefer precompiled kmod packages corresponding to installed kernels
    - don't resolve suggested virtual packages if already installed (#34376)
    - 2.06: also handle promotion via obsolete for conflicts
    - 2.05:
    - package promotion must respect strict_arch
    - enhance sorted graph by better taking into account conflicts from state->{rejected}
      (fixes "big transaction" in urpmi split-transactions--strict-require.t test)
    - 2.04: handle promotion via obsolete, not only provides
    - 2.03: fix bug doing "urpmi kernel-source"
    - 2.02:
    - prefer every kernel-<flavor>-devel-<version> packages for which
      kernel-<flavor>-<version> is selected
    - fix regression in 2.00: we can't cache the platform, cache the result of
      is_arch_compat instead
    - bug fix release, 2.01:
    - fix bug occurring with --keep
    - fix regression in 2.00: keep_unrequested_dependencies is still used by
      installer. restore it, but must now be set trough
      $urpm->{keep_unrequested_dependencies}
    - new major release 2.00 since many things have changed in the algorithm
      (but no API breakage)
    - speedup is_arch_compat (7 times faster) by keeping the platform in a cache
    - do not propose packages for non installed locales
    - pass the prefered choices to {callback_choices}: this allows urpmi to select
      all the prefered packages according to installed locales
    - handle promote for conflict from installed package
      (fixes test_gh() from urpmi split-transactions--promote test case)
    - handle promote from installed package which require a unselected package,
      whereas new package does not require it anymore
      (cf test_d & test_e from split-transactions--conflict urpmi test case)
    - bug fix release, 1.80:
    - fix bug in sort_graph (used by build_transaction_set)
    - bug fix release, 1.79:
    - fix bug in sort_graph (used by build_transaction_set)
    - bug fix release, 1.78
    - fix dead-loop in build_transaction_set (#33020)
    - new release, 1.77
    - disable "dropping tags from rpm header" until we can safely use it
    - new release, 1.76
    - build_transaction_set: new sort algorithm which allow returning sets of
      circular dependent packages, taking into account obsoleted packages
      (fixes #31969). It may still fail in presence of conflicts
    - allow running transaction with justdb option
    - fix split_length > 1
      (eg: "urpmi --split-length 2 a b c" will only install 2 pkgs)
    - spec2srcheader: workaround parseSpec returning a header where ->arch is set
      to %%{_target_cpu} whereas we really want a header similar to .src.rpm
      (see #32824)
    - new release, 1.75
    - fix dropping tags from rpm header.
      it hasn't work since MDK8.1 and rpm 4.0.
      it may break urpmi!! but potentially allows a much smaller hdlist.cz :)
    - new release, 1.74
    - sort choices per media, then per version
    - new release, 1.73
    - allow running transaction with replagekgs option
    - new release, 1.72
    - modify parse_hdlist so that partial hdlist reading can be used
      (needed when some stuff is already done in the callback)
    - new release 1.71
    - compilation fixes on rpm < 4.4.8
    - new release 1.70
    - compilation fixes on rpm < 4.4.8
    - new release, 1.69
    - "suggests" are no more handled as "requires"
    - resolve_requested support "suggests": a newly suggested package is installed
      as if required (can be disabled with option no_suggests)
    - new release, 1.68
    - add $trans->Element_version and $trans->Element_release
    - new release, 1.66:
    - fix --auto-select skipping some packages because of other packages providing
      a more recent version, but no obsolete between those packages.
      the fix is to revert commit from Aug 2002:
        "fixed propable old package (according provides) requested by
         request_packages_to_upgrade."
    - bug fix release 1.64 for rpm 4.4.8
    - hack on $pkg->is_arch_compat to make it return true for noarch packages
      when using rpm 4.4.8 (#31314)
    - new release, 1.63
    - add $trans->Element_fullname
    - new release, 1.62
    - pass the virtual package name as a parameter to {callback_choices} in
      ->resolve_requested
    - add $trans->NElements and $trans->Element_name
      to be able to display name of uninstalled package in callback_uninst
    - fix b--obsoletes-->a and c--conflicts-->a prompting for upgrading a
      (need a fix in urpmi which rely on the $state->{rejected}
       to upgrade (-U) b instead of installing (-i) it)

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Anssi Hannula <anssi@mandriva.org>
    - rebuild with correct optflags

